<?php
/**
 * InlineObject27
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject27 Class Doc Comment
 *
 * @category Class
 * @description object containing support list query parameters.  When querying support with these parameters, you can only use the filter settings you need (You don&#39;t have to specify all)
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject27 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_27';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'timeframe' => 'object',
        'supportLocations' => 'string[]',
        'supportIconTypes' => 'string[]',
        'companies' => 'int[]',
        'employees' => 'int[]',
        'internalSupport' => 'string',
        'companyCategories' => 'int[]',
        'companyCategoriesMatchType' => 'string',
        'excludeOwnCompany' => 'bool',
        'invoiceNumber' => 'string',
        'excludeExternalEmployees' => 'bool',
        'discountedSupports' => 'string',
        'notChargedReasons' => 'int[]',
        'departmentFilter' => 'int[]',
        'ticketTypes' => 'int[]',
        'tickets' => 'int[]',
        'ticketPhases' => 'int[]',
        'linkTypes' => 'int[]',
        'supportTypes' => 'int[]',
        'includeSubTickets' => 'bool',
        'planningTypes' => 'string[]',
        'textFilter' => 'string',
        'useRelations' => 'bool',
        'openTickets' => 'string',
        'taskFilter' => 'string',
        'importTypes' => 'object[]',
        'contracts' => 'int[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'timeframe' => null,
        'supportLocations' => null,
        'supportIconTypes' => null,
        'companies' => null,
        'employees' => null,
        'internalSupport' => null,
        'companyCategories' => null,
        'companyCategoriesMatchType' => null,
        'excludeOwnCompany' => null,
        'invoiceNumber' => null,
        'excludeExternalEmployees' => null,
        'discountedSupports' => null,
        'notChargedReasons' => null,
        'departmentFilter' => null,
        'ticketTypes' => null,
        'tickets' => null,
        'ticketPhases' => null,
        'linkTypes' => null,
        'supportTypes' => null,
        'includeSubTickets' => null,
        'planningTypes' => null,
        'textFilter' => null,
        'useRelations' => null,
        'openTickets' => null,
        'taskFilter' => null,
        'importTypes' => null,
        'contracts' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timeframe' => 'timeframe',
        'supportLocations' => 'supportLocations',
        'supportIconTypes' => 'supportIconTypes',
        'companies' => 'companies',
        'employees' => 'employees',
        'internalSupport' => 'internalSupport',
        'companyCategories' => 'companyCategories',
        'companyCategoriesMatchType' => 'companyCategoriesMatchType',
        'excludeOwnCompany' => 'excludeOwnCompany',
        'invoiceNumber' => 'invoiceNumber',
        'excludeExternalEmployees' => 'excludeExternalEmployees',
        'discountedSupports' => 'discountedSupports',
        'notChargedReasons' => 'notChargedReasons',
        'departmentFilter' => 'departmentFilter',
        'ticketTypes' => 'ticketTypes',
        'tickets' => 'tickets',
        'ticketPhases' => 'ticketPhases',
        'linkTypes' => 'linkTypes',
        'supportTypes' => 'supportTypes',
        'includeSubTickets' => 'includeSubTickets',
        'planningTypes' => 'planningTypes',
        'textFilter' => 'textFilter',
        'useRelations' => 'useRelations',
        'openTickets' => 'openTickets',
        'taskFilter' => 'taskFilter',
        'importTypes' => 'importTypes',
        'contracts' => 'contracts'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timeframe' => 'setTimeframe',
        'supportLocations' => 'setSupportLocations',
        'supportIconTypes' => 'setSupportIconTypes',
        'companies' => 'setCompanies',
        'employees' => 'setEmployees',
        'internalSupport' => 'setInternalSupport',
        'companyCategories' => 'setCompanyCategories',
        'companyCategoriesMatchType' => 'setCompanyCategoriesMatchType',
        'excludeOwnCompany' => 'setExcludeOwnCompany',
        'invoiceNumber' => 'setInvoiceNumber',
        'excludeExternalEmployees' => 'setExcludeExternalEmployees',
        'discountedSupports' => 'setDiscountedSupports',
        'notChargedReasons' => 'setNotChargedReasons',
        'departmentFilter' => 'setDepartmentFilter',
        'ticketTypes' => 'setTicketTypes',
        'tickets' => 'setTickets',
        'ticketPhases' => 'setTicketPhases',
        'linkTypes' => 'setLinkTypes',
        'supportTypes' => 'setSupportTypes',
        'includeSubTickets' => 'setIncludeSubTickets',
        'planningTypes' => 'setPlanningTypes',
        'textFilter' => 'setTextFilter',
        'useRelations' => 'setUseRelations',
        'openTickets' => 'setOpenTickets',
        'taskFilter' => 'setTaskFilter',
        'importTypes' => 'setImportTypes',
        'contracts' => 'setContracts'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timeframe' => 'getTimeframe',
        'supportLocations' => 'getSupportLocations',
        'supportIconTypes' => 'getSupportIconTypes',
        'companies' => 'getCompanies',
        'employees' => 'getEmployees',
        'internalSupport' => 'getInternalSupport',
        'companyCategories' => 'getCompanyCategories',
        'companyCategoriesMatchType' => 'getCompanyCategoriesMatchType',
        'excludeOwnCompany' => 'getExcludeOwnCompany',
        'invoiceNumber' => 'getInvoiceNumber',
        'excludeExternalEmployees' => 'getExcludeExternalEmployees',
        'discountedSupports' => 'getDiscountedSupports',
        'notChargedReasons' => 'getNotChargedReasons',
        'departmentFilter' => 'getDepartmentFilter',
        'ticketTypes' => 'getTicketTypes',
        'tickets' => 'getTickets',
        'ticketPhases' => 'getTicketPhases',
        'linkTypes' => 'getLinkTypes',
        'supportTypes' => 'getSupportTypes',
        'includeSubTickets' => 'getIncludeSubTickets',
        'planningTypes' => 'getPlanningTypes',
        'textFilter' => 'getTextFilter',
        'useRelations' => 'getUseRelations',
        'openTickets' => 'getOpenTickets',
        'taskFilter' => 'getTaskFilter',
        'importTypes' => 'getImportTypes',
        'contracts' => 'getContracts'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const SUPPORT_LOCATIONS_OFFICE = 'OFFICE';
    public const SUPPORT_LOCATIONS_CUSTOMER = 'CUSTOMER';
    public const SUPPORT_LOCATIONS_REMOTE = 'REMOTE';
    public const SUPPORT_ICON_TYPES_STANDARD = 'STANDARD';
    public const SUPPORT_ICON_TYPES_REMOTE = 'REMOTE';
    public const SUPPORT_ICON_TYPES_NOT_CHARGED = 'NOT_CHARGED';
    public const SUPPORT_ICON_TYPES_ERP = 'ERP';
    public const SUPPORT_ICON_TYPES_INSTALLATION_FEE = 'INSTALLATION_FEE';
    public const SUPPORT_ICON_TYPES_FULLSERVICE = 'FULLSERVICE';
    public const SUPPORT_ICON_TYPES_CONTRACT = 'CONTRACT';
    public const SUPPORT_ICON_TYPES_PREPAID = 'PREPAID';
    public const INTERNAL_SUPPORT_ALL = 'ALL';
    public const INTERNAL_SUPPORT_ONLY_INTERNAL = 'ONLY_INTERNAL';
    public const INTERNAL_SUPPORT_ONLY_EXTERNAL = 'ONLY_EXTERNAL';
    public const COMPANY_CATEGORIES_MATCH_TYPE__AND = 'AND';
    public const COMPANY_CATEGORIES_MATCH_TYPE__OR = 'OR';
    public const COMPANY_CATEGORIES_MATCH_TYPE_NOT = 'NOT';
    public const DISCOUNTED_SUPPORTS_ALL = 'ALL';
    public const DISCOUNTED_SUPPORTS_ONLY_WITH_ADDITION = 'ONLY_WITH_ADDITION';
    public const DISCOUNTED_SUPPORTS_ONLY_WITH_DISCOUNT = 'ONLY_WITH_DISCOUNT';
    public const DISCOUNTED_SUPPORTS_ONLY_WITH_ZERO_PERCENT = 'ONLY_WITH_ZERO_PERCENT';
    public const PLANNING_TYPES_SUPPORT = 'SUPPORT';
    public const PLANNING_TYPES_APPOINTMENT_PROPOSAL = 'APPOINTMENT_PROPOSAL';
    public const PLANNING_TYPES_APPOINTMENT_FIX = 'APPOINTMENT_FIX';
    public const PLANNING_TYPES_VACATION = 'VACATION';
    public const PLANNING_TYPES_ILLNESS = 'ILLNESS';
    public const PLANNING_TYPES_ABSENCE = 'ABSENCE';
    public const PLANNING_TYPES_STAND_BY = 'STAND_BY';
    public const PLANNING_TYPES_APPOINTMENT_PRIVATE = 'APPOINTMENT_PRIVATE';
    public const PLANNING_TYPES_OVERTIME = 'OVERTIME';
    public const OPEN_TICKETS_SUPPORTS_FROM_ALL_TICKETS = 'SUPPORTS_FROM_ALL_TICKETS';
    public const OPEN_TICKETS_SUPPORTS_FROM_OPEN_TICKETS = 'SUPPORTS_FROM_OPEN_TICKETS';
    public const OPEN_TICKETS_SUPPORTS_FROM_CLOSED_TICKETS = 'SUPPORTS_FROM_CLOSED_TICKETS';
    public const OPEN_TICKETS_ALL_SUPPORTS_BUT_OPEN_TICKETS = 'ALL_SUPPORTS_BUT_OPEN_TICKETS';
    public const TASK_FILTER_ONLY_TASK_SUPPORTS = 'ONLY_TASK_SUPPORTS';
    public const TASK_FILTER_NO_TASK_SUPPORTS = 'NO_TASK_SUPPORTS';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSupportLocationsAllowableValues()
    {
        return [
            self::SUPPORT_LOCATIONS_OFFICE,
            self::SUPPORT_LOCATIONS_CUSTOMER,
            self::SUPPORT_LOCATIONS_REMOTE,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSupportIconTypesAllowableValues()
    {
        return [
            self::SUPPORT_ICON_TYPES_STANDARD,
            self::SUPPORT_ICON_TYPES_REMOTE,
            self::SUPPORT_ICON_TYPES_NOT_CHARGED,
            self::SUPPORT_ICON_TYPES_ERP,
            self::SUPPORT_ICON_TYPES_INSTALLATION_FEE,
            self::SUPPORT_ICON_TYPES_FULLSERVICE,
            self::SUPPORT_ICON_TYPES_CONTRACT,
            self::SUPPORT_ICON_TYPES_PREPAID,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getInternalSupportAllowableValues()
    {
        return [
            self::INTERNAL_SUPPORT_ALL,
            self::INTERNAL_SUPPORT_ONLY_INTERNAL,
            self::INTERNAL_SUPPORT_ONLY_EXTERNAL,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getCompanyCategoriesMatchTypeAllowableValues()
    {
        return [
            self::COMPANY_CATEGORIES_MATCH_TYPE__AND,
            self::COMPANY_CATEGORIES_MATCH_TYPE__OR,
            self::COMPANY_CATEGORIES_MATCH_TYPE_NOT,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getDiscountedSupportsAllowableValues()
    {
        return [
            self::DISCOUNTED_SUPPORTS_ALL,
            self::DISCOUNTED_SUPPORTS_ONLY_WITH_ADDITION,
            self::DISCOUNTED_SUPPORTS_ONLY_WITH_DISCOUNT,
            self::DISCOUNTED_SUPPORTS_ONLY_WITH_ZERO_PERCENT,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPlanningTypesAllowableValues()
    {
        return [
            self::PLANNING_TYPES_SUPPORT,
            self::PLANNING_TYPES_APPOINTMENT_PROPOSAL,
            self::PLANNING_TYPES_APPOINTMENT_FIX,
            self::PLANNING_TYPES_VACATION,
            self::PLANNING_TYPES_ILLNESS,
            self::PLANNING_TYPES_ABSENCE,
            self::PLANNING_TYPES_STAND_BY,
            self::PLANNING_TYPES_APPOINTMENT_PRIVATE,
            self::PLANNING_TYPES_OVERTIME,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getOpenTicketsAllowableValues()
    {
        return [
            self::OPEN_TICKETS_SUPPORTS_FROM_ALL_TICKETS,
            self::OPEN_TICKETS_SUPPORTS_FROM_OPEN_TICKETS,
            self::OPEN_TICKETS_SUPPORTS_FROM_CLOSED_TICKETS,
            self::OPEN_TICKETS_ALL_SUPPORTS_BUT_OPEN_TICKETS,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getTaskFilterAllowableValues()
    {
        return [
            self::TASK_FILTER_ONLY_TASK_SUPPORTS,
            self::TASK_FILTER_NO_TASK_SUPPORTS,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timeframe'] = $data['timeframe'] ?? null;
        $this->container['supportLocations'] = $data['supportLocations'] ?? null;
        $this->container['supportIconTypes'] = $data['supportIconTypes'] ?? null;
        $this->container['companies'] = $data['companies'] ?? null;
        $this->container['employees'] = $data['employees'] ?? null;
        $this->container['internalSupport'] = $data['internalSupport'] ?? null;
        $this->container['companyCategories'] = $data['companyCategories'] ?? null;
        $this->container['companyCategoriesMatchType'] = $data['companyCategoriesMatchType'] ?? null;
        $this->container['excludeOwnCompany'] = $data['excludeOwnCompany'] ?? null;
        $this->container['invoiceNumber'] = $data['invoiceNumber'] ?? null;
        $this->container['excludeExternalEmployees'] = $data['excludeExternalEmployees'] ?? null;
        $this->container['discountedSupports'] = $data['discountedSupports'] ?? null;
        $this->container['notChargedReasons'] = $data['notChargedReasons'] ?? null;
        $this->container['departmentFilter'] = $data['departmentFilter'] ?? null;
        $this->container['ticketTypes'] = $data['ticketTypes'] ?? null;
        $this->container['tickets'] = $data['tickets'] ?? null;
        $this->container['ticketPhases'] = $data['ticketPhases'] ?? null;
        $this->container['linkTypes'] = $data['linkTypes'] ?? null;
        $this->container['supportTypes'] = $data['supportTypes'] ?? null;
        $this->container['includeSubTickets'] = $data['includeSubTickets'] ?? null;
        $this->container['planningTypes'] = $data['planningTypes'] ?? null;
        $this->container['textFilter'] = $data['textFilter'] ?? null;
        $this->container['useRelations'] = $data['useRelations'] ?? null;
        $this->container['openTickets'] = $data['openTickets'] ?? null;
        $this->container['taskFilter'] = $data['taskFilter'] ?? null;
        $this->container['importTypes'] = $data['importTypes'] ?? null;
        $this->container['contracts'] = $data['contracts'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getInternalSupportAllowableValues();
        if (!is_null($this->container['internalSupport']) && !in_array($this->container['internalSupport'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'internalSupport', must be one of '%s'",
                $this->container['internalSupport'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getCompanyCategoriesMatchTypeAllowableValues();
        if (!is_null($this->container['companyCategoriesMatchType']) && !in_array($this->container['companyCategoriesMatchType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'companyCategoriesMatchType', must be one of '%s'",
                $this->container['companyCategoriesMatchType'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getDiscountedSupportsAllowableValues();
        if (!is_null($this->container['discountedSupports']) && !in_array($this->container['discountedSupports'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'discountedSupports', must be one of '%s'",
                $this->container['discountedSupports'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getOpenTicketsAllowableValues();
        if (!is_null($this->container['openTickets']) && !in_array($this->container['openTickets'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'openTickets', must be one of '%s'",
                $this->container['openTickets'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getTaskFilterAllowableValues();
        if (!is_null($this->container['taskFilter']) && !in_array($this->container['taskFilter'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'taskFilter', must be one of '%s'",
                $this->container['taskFilter'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timeframe
     *
     * @return object|null
     */
    public function getTimeframe()
    {
        return $this->container['timeframe'];
    }

    /**
     * Sets timeframe
     *
     * @param object|null $timeframe timeframe
     *
     * @return self
     */
    public function setTimeframe($timeframe)
    {
        $this->container['timeframe'] = $timeframe;

        return $this;
    }

    /**
     * Gets supportLocations
     *
     * @return string[]|null
     */
    public function getSupportLocations()
    {
        return $this->container['supportLocations'];
    }

    /**
     * Sets supportLocations
     *
     * @param string[]|null $supportLocations show only supports from these support locations
     *
     * @return self
     */
    public function setSupportLocations($supportLocations)
    {
        $allowedValues = $this->getSupportLocationsAllowableValues();
        if (!is_null($supportLocations) && array_diff($supportLocations, $allowedValues)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'supportLocations', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['supportLocations'] = $supportLocations;

        return $this;
    }

    /**
     * Gets supportIconTypes
     *
     * @return string[]|null
     */
    public function getSupportIconTypes()
    {
        return $this->container['supportIconTypes'];
    }

    /**
     * Sets supportIconTypes
     *
     * @param string[]|null $supportIconTypes show only supports with these support icon types
     *
     * @return self
     */
    public function setSupportIconTypes($supportIconTypes)
    {
        $allowedValues = $this->getSupportIconTypesAllowableValues();
        if (!is_null($supportIconTypes) && array_diff($supportIconTypes, $allowedValues)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'supportIconTypes', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['supportIconTypes'] = $supportIconTypes;

        return $this;
    }

    /**
     * Gets companies
     *
     * @return int[]|null
     */
    public function getCompanies()
    {
        return $this->container['companies'];
    }

    /**
     * Sets companies
     *
     * @param int[]|null $companies show only supports from this companies (ids)
     *
     * @return self
     */
    public function setCompanies($companies)
    {
        $this->container['companies'] = $companies;

        return $this;
    }

    /**
     * Gets employees
     *
     * @return int[]|null
     */
    public function getEmployees()
    {
        return $this->container['employees'];
    }

    /**
     * Sets employees
     *
     * @param int[]|null $employees filter for emmployees (technician) ids
     *
     * @return self
     */
    public function setEmployees($employees)
    {
        $this->container['employees'] = $employees;

        return $this;
    }

    /**
     * Gets internalSupport
     *
     * @return string|null
     */
    public function getInternalSupport()
    {
        return $this->container['internalSupport'];
    }

    /**
     * Sets internalSupport
     *
     * @param string|null $internalSupport determines which filter for \"internal support\" shall be used
     *
     * @return self
     */
    public function setInternalSupport($internalSupport)
    {
        $allowedValues = $this->getInternalSupportAllowableValues();
        if (!is_null($internalSupport) && !in_array($internalSupport, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'internalSupport', must be one of '%s'",
                    $internalSupport,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['internalSupport'] = $internalSupport;

        return $this;
    }

    /**
     * Gets companyCategories
     *
     * @return int[]|null
     */
    public function getCompanyCategories()
    {
        return $this->container['companyCategories'];
    }

    /**
     * Sets companyCategories
     *
     * @param int[]|null $companyCategories show supports from these company categories (ids)
     *
     * @return self
     */
    public function setCompanyCategories($companyCategories)
    {
        $this->container['companyCategories'] = $companyCategories;

        return $this;
    }

    /**
     * Gets companyCategoriesMatchType
     *
     * @return string|null
     */
    public function getCompanyCategoriesMatchType()
    {
        return $this->container['companyCategoriesMatchType'];
    }

    /**
     * Sets companyCategoriesMatchType
     *
     * @param string|null $companyCategoriesMatchType Enum representing the logic linking of certain ids (AND / NOT / OR)
     *
     * @return self
     */
    public function setCompanyCategoriesMatchType($companyCategoriesMatchType)
    {
        $allowedValues = $this->getCompanyCategoriesMatchTypeAllowableValues();
        if (!is_null($companyCategoriesMatchType) && !in_array($companyCategoriesMatchType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'companyCategoriesMatchType', must be one of '%s'",
                    $companyCategoriesMatchType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['companyCategoriesMatchType'] = $companyCategoriesMatchType;

        return $this;
    }

    /**
     * Gets excludeOwnCompany
     *
     * @return bool|null
     */
    public function getExcludeOwnCompany()
    {
        return $this->container['excludeOwnCompany'];
    }

    /**
     * Sets excludeOwnCompany
     *
     * @param bool|null $excludeOwnCompany true, if supports from the own company shall be excluded
     *
     * @return self
     */
    public function setExcludeOwnCompany($excludeOwnCompany)
    {
        $this->container['excludeOwnCompany'] = $excludeOwnCompany;

        return $this;
    }

    /**
     * Gets invoiceNumber
     *
     * @return string|null
     */
    public function getInvoiceNumber()
    {
        return $this->container['invoiceNumber'];
    }

    /**
     * Sets invoiceNumber
     *
     * @param string|null $invoiceNumber filter for a certain invoice (erp) number
     *
     * @return self
     */
    public function setInvoiceNumber($invoiceNumber)
    {
        $this->container['invoiceNumber'] = $invoiceNumber;

        return $this;
    }

    /**
     * Gets excludeExternalEmployees
     *
     * @return bool|null
     */
    public function getExcludeExternalEmployees()
    {
        return $this->container['excludeExternalEmployees'];
    }

    /**
     * Sets excludeExternalEmployees
     *
     * @param bool|null $excludeExternalEmployees true if external employees shall be excluded
     *
     * @return self
     */
    public function setExcludeExternalEmployees($excludeExternalEmployees)
    {
        $this->container['excludeExternalEmployees'] = $excludeExternalEmployees;

        return $this;
    }

    /**
     * Gets discountedSupports
     *
     * @return string|null
     */
    public function getDiscountedSupports()
    {
        return $this->container['discountedSupports'];
    }

    /**
     * Sets discountedSupports
     *
     * @param string|null $discountedSupports determines which filter for \"discounted\" supports shall be used
     *
     * @return self
     */
    public function setDiscountedSupports($discountedSupports)
    {
        $allowedValues = $this->getDiscountedSupportsAllowableValues();
        if (!is_null($discountedSupports) && !in_array($discountedSupports, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'discountedSupports', must be one of '%s'",
                    $discountedSupports,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['discountedSupports'] = $discountedSupports;

        return $this;
    }

    /**
     * Gets notChargedReasons
     *
     * @return int[]|null
     */
    public function getNotChargedReasons()
    {
        return $this->container['notChargedReasons'];
    }

    /**
     * Sets notChargedReasons
     *
     * @param int[]|null $notChargedReasons show supports from these \"Not charged reasons\" only
     *
     * @return self
     */
    public function setNotChargedReasons($notChargedReasons)
    {
        $this->container['notChargedReasons'] = $notChargedReasons;

        return $this;
    }

    /**
     * Gets departmentFilter
     *
     * @return int[]|null
     */
    public function getDepartmentFilter()
    {
        return $this->container['departmentFilter'];
    }

    /**
     * Sets departmentFilter
     *
     * @param int[]|null $departmentFilter show supports from these departments only
     *
     * @return self
     */
    public function setDepartmentFilter($departmentFilter)
    {
        $this->container['departmentFilter'] = $departmentFilter;

        return $this;
    }

    /**
     * Gets ticketTypes
     *
     * @return int[]|null
     */
    public function getTicketTypes()
    {
        return $this->container['ticketTypes'];
    }

    /**
     * Sets ticketTypes
     *
     * @param int[]|null $ticketTypes show supports from these ticket types
     *
     * @return self
     */
    public function setTicketTypes($ticketTypes)
    {
        $this->container['ticketTypes'] = $ticketTypes;

        return $this;
    }

    /**
     * Gets tickets
     *
     * @return int[]|null
     */
    public function getTickets()
    {
        return $this->container['tickets'];
    }

    /**
     * Sets tickets
     *
     * @param int[]|null $tickets show supports from these ticket (ids) only
     *
     * @return self
     */
    public function setTickets($tickets)
    {
        $this->container['tickets'] = $tickets;

        return $this;
    }

    /**
     * Gets ticketPhases
     *
     * @return int[]|null
     */
    public function getTicketPhases()
    {
        return $this->container['ticketPhases'];
    }

    /**
     * Sets ticketPhases
     *
     * @param int[]|null $ticketPhases show supports from these ticket phases only
     *
     * @return self
     */
    public function setTicketPhases($ticketPhases)
    {
        $this->container['ticketPhases'] = $ticketPhases;

        return $this;
    }

    /**
     * Gets linkTypes
     *
     * @return int[]|null
     */
    public function getLinkTypes()
    {
        return $this->container['linkTypes'];
    }

    /**
     * Sets linkTypes
     *
     * @param int[]|null $linkTypes show supports from these link types only
     *
     * @return self
     */
    public function setLinkTypes($linkTypes)
    {
        $this->container['linkTypes'] = $linkTypes;

        return $this;
    }

    /**
     * Gets supportTypes
     *
     * @return int[]|null
     */
    public function getSupportTypes()
    {
        return $this->container['supportTypes'];
    }

    /**
     * Sets supportTypes
     *
     * @param int[]|null $supportTypes show supports from these support types only
     *
     * @return self
     */
    public function setSupportTypes($supportTypes)
    {
        $this->container['supportTypes'] = $supportTypes;

        return $this;
    }

    /**
     * Gets includeSubTickets
     *
     * @return bool|null
     */
    public function getIncludeSubTickets()
    {
        return $this->container['includeSubTickets'];
    }

    /**
     * Sets includeSubTickets
     *
     * @param bool|null $includeSubTickets if true, all sub-ticket supports will be included as well (when displaying support from projects)
     *
     * @return self
     */
    public function setIncludeSubTickets($includeSubTickets)
    {
        $this->container['includeSubTickets'] = $includeSubTickets;

        return $this;
    }

    /**
     * Gets planningTypes
     *
     * @return string[]|null
     */
    public function getPlanningTypes()
    {
        return $this->container['planningTypes'];
    }

    /**
     * Sets planningTypes
     *
     * @param string[]|null $planningTypes show supports from these planning types only
     *
     * @return self
     */
    public function setPlanningTypes($planningTypes)
    {
        $allowedValues = $this->getPlanningTypesAllowableValues();
        if (!is_null($planningTypes) && array_diff($planningTypes, $allowedValues)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'planningTypes', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['planningTypes'] = $planningTypes;

        return $this;
    }

    /**
     * Gets textFilter
     *
     * @return string|null
     */
    public function getTextFilter()
    {
        return $this->container['textFilter'];
    }

    /**
     * Sets textFilter
     *
     * @param string|null $textFilter if filtering for support containing a given text, you can specify the text filter here
     *
     * @return self
     */
    public function setTextFilter($textFilter)
    {
        $this->container['textFilter'] = $textFilter;

        return $this;
    }

    /**
     * Gets useRelations
     *
     * @return bool|null
     */
    public function getUseRelations()
    {
        return $this->container['useRelations'];
    }

    /**
     * Sets useRelations
     *
     * @param bool|null $useRelations true if relation supports shall fe fecthed as well (when specifying company filter)
     *
     * @return self
     */
    public function setUseRelations($useRelations)
    {
        $this->container['useRelations'] = $useRelations;

        return $this;
    }

    /**
     * Gets openTickets
     *
     * @return string|null
     */
    public function getOpenTickets()
    {
        return $this->container['openTickets'];
    }

    /**
     * Sets openTickets
     *
     * @param string|null $openTickets determines wether supports from open tickets shall be fecthed or not
     *
     * @return self
     */
    public function setOpenTickets($openTickets)
    {
        $allowedValues = $this->getOpenTicketsAllowableValues();
        if (!is_null($openTickets) && !in_array($openTickets, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'openTickets', must be one of '%s'",
                    $openTickets,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['openTickets'] = $openTickets;

        return $this;
    }

    /**
     * Gets taskFilter
     *
     * @return string|null
     */
    public function getTaskFilter()
    {
        return $this->container['taskFilter'];
    }

    /**
     * Sets taskFilter
     *
     * @param string|null $taskFilter determines wether supports from tasks shall be fetched as well
     *
     * @return self
     */
    public function setTaskFilter($taskFilter)
    {
        $allowedValues = $this->getTaskFilterAllowableValues();
        if (!is_null($taskFilter) && !in_array($taskFilter, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'taskFilter', must be one of '%s'",
                    $taskFilter,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['taskFilter'] = $taskFilter;

        return $this;
    }

    /**
     * Gets importTypes
     *
     * @return object[]|null
     */
    public function getImportTypes()
    {
        return $this->container['importTypes'];
    }

    /**
     * Sets importTypes
     *
     * @param object[]|null $importTypes show supports from these support \"import types\" only
     *
     * @return self
     */
    public function setImportTypes($importTypes)
    {
        $this->container['importTypes'] = $importTypes;

        return $this;
    }

    /**
     * Gets contracts
     *
     * @return int[]|null
     */
    public function getContracts()
    {
        return $this->container['contracts'];
    }

    /**
     * Sets contracts
     *
     * @param int[]|null $contracts show supports from these contracts (ids)
     *
     * @return self
     */
    public function setContracts($contracts)
    {
        $this->container['contracts'] = $contracts;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


